import java.util.Comparator;
import java.util.Objects;

public class PlaneCompareByType implements Comparator<IDrawningObject>
{
    @Override
    public int compare(IDrawningObject x, IDrawningObject y)
    {
        if (x == null && y == null)
        {
            return 0;
        }

        if (x == null && y != null)
        {
            return 1;
        }

        if (x != null && y == null)
        {
            return -1;
        }

        DrawningObjectPlane xPlane = (DrawningObjectPlane)x;
        DrawningObjectPlane yPlane = (DrawningObjectPlane)y;

        if (xPlane == null && yPlane == null)
        {
            return 0;
        }

        if (xPlane == null && yPlane != null)
        {
            return 1;
        }

        if (xPlane != null && yPlane == null)
        {
            return -1;
        }


        if(!Objects.equals(xPlane.GetPlane().getClass(), yPlane.GetPlane().getClass()))
        {
            if(xPlane.GetPlane().getClass().getSimpleName() == "DrawingPlane")
            {
                return -1;
            }

            return 1;
        }

        String xStyleWindows = xPlane.GetPlane()._airplaneWindow.getClass().getSimpleName();
        String yStyleWindows = yPlane.GetPlane()._airplaneWindow.getClass().getSimpleName();
        int styleCompare = xStyleWindows.compareTo(yStyleWindows);

        if(styleCompare != 0){
            return styleCompare;
        }

        Integer xCountWindows = xPlane.GetPlane()._countWindows;
        Integer yCountWindows = yPlane.GetPlane()._countWindows;
        int countWindowsCompare = xCountWindows.compareTo(yCountWindows);

        if(countWindowsCompare != 0){
            return countWindowsCompare;
        }

        Integer speedCompare1 = xPlane.GetPlane().Plane.GetSpeed();
        Integer speedCompare2 = yPlane.GetPlane().Plane.GetSpeed();
        var speedCompare = speedCompare1.compareTo(speedCompare2);

        if(speedCompare != 0)
        {
            return speedCompare;
        }

        Float weightCompare1 = xPlane.GetPlane().Plane.GetWeight();
        Float weightCompare2 = yPlane.GetPlane().Plane.GetWeight();

        return weightCompare1.compareTo(weightCompare2);
    }
}
